%% This function looks invalid inputs. If there's any invalid input, it displays a message and returns false.
function [ok] = check_contents(handles)
ok = true;
for useless_variable = 1:1
    minK = str2double(get(handles.eTminK,'String'));
    if (isnan(minK) || mod(minK,1)~=0)
        set_message(handles,'The minimum number of summary piles must be an integer number.','error');
        ok = false;
        break;
    elseif minK < 1
        set_message(handles,'The minimum number of summary piles must be greater than or equal to 1.','error');
        ok = false;
        break;
    end
    maxK = str2double(get(handles.eTmaxK,'String'));
    if (isnan(maxK) || mod(maxK,1)~=0)
        set_message(handles,'The maximum number of summary piles must be an integer number.','error');
        ok = false;
        break;
    elseif maxK < 1
        set_message(handles,'The maximum number of summary piles must be greater than or equal to 1.','error');
        ok = false;
        break;
    elseif minK > maxK
        set_message(handles,'The maximum number of summary piles must be greater than or equal to the minimum number.','error');
        ok = false;
        break;
    end
    runs = str2double(get(handles.eTruns,'String'));
    if (isnan(runs) || mod(runs,1)~=0)
        set_message(handles,'The number replications must be an integer number.','error');
        ok = false;
        break;
    elseif runs < 1
        set_message(handles,'The number replications must be greater than or equal to 1.','error');
        ok = false;
        break;
    end
    repetitions = str2double(get(handles.eTrepetitions,'String'));
    if (isnan(repetitions) || mod(repetitions,1)~=0)
        set_message(handles,'The minimum number of equal piles must be an integer number.','error');
        ok = false;
        break;
    elseif repetitions < 1
        set_message(handles,'The minimum number of equal piles must be greater than or equal to 1.','error');
        ok = false;
        break;
    end
    seed = str2double(get(handles.eTseed,'String'));
    if (isnan(seed) || mod(seed,1)~=0)
        set_message(handles,'The random seed must be an integer number.','error');
        ok = false;
        break;
    elseif seed < 0
        set_message(handles,'The random seed must be greater than or equal to 0.','error');
        ok = false;
        break;
    end
    maxiterations = str2double(get(handles.eTmaxiterations,'String'));
    if (isnan(maxiterations) || mod(maxiterations,1)~=0)
        set_message(handles,'The maximum number of iterations per execution must be an integer number.','error');
        ok = false;
        break;
    elseif maxiterations < 1
        set_message(handles,'The maximum number of iterations per execution must be greater than or equal to 1.','error');
        ok = false;
        break;
    end
    timelimit = str2double(get(handles.eTtimelimit,'String'));
    if (isnan(timelimit) || mod(timelimit,1)~=0)
        set_message(handles,'The time limit per execution must be an integer number.','error');
        ok = false;
        break;
    end
    displayinterval = str2double(get(handles.eTdisplayinterval,'String'));
    if (isnan(displayinterval) || mod(displayinterval,1)~=0)
        set_message(handles,'The number of iterations for log update must be an integer number.','error');
        ok = false;
        break;
    end
end
end

