%% This function returns the cost and assignments of each pile to summary piles given the summary piles
function [ximli,Z,mismatches]=get_cost(pmj,yilij,weights)
%% Inputs:
% pmj: summary piles
% yilij: piles
% weights: number of times each pile was created

%% Output:
% ximli: cell where each value equals to 1 if pile li is assigned to summary pile m
% Z: solution cost
% mismatches: mismatches between piles and summary piles

%%
Z=0;

[K,J]=size(pmj{1});
I=length(yilij);

ximli=cell(I,1);

mismatches=cell(I,1);

for i=1:I
    mismatches{i} = J-(pmj{1}*yilij{i}' + (1-pmj{1})*(1-yilij{i}'));
    
    ci = size(yilij{i},1);
    
    ximli(i,1)={zeros(K,ci)};
    
    for li=1:ci
        [val,id]=min(mismatches{i}(:,li));
        Z=Z+val*weights{1}(li);
        ximli{i}(id,li)=1;
    end
end

end