%% This function returns the cost and assignments of each pile to summary piles given the summary piles. Piles from the same individual must be covered by different summay piles
function [ximli,Z]=get_costOPPSP(pmj,yilij)
%% Inputs:
% pmj: summary piles
% yilij: piles

%% Output:
% ximli: cell where each value equals to 1 if pile li is assigned to summary pile m
% Z: solution cost

%%
Z=0;

[K,J]=size(pmj{1});
I=length(yilij);
ci=zeros(1,I);
for i=1:I
    ci(i)=size(yilij{i},1);
end

ximli=cell(I,1);

for i=1:I
    mismatches = J-(pmj{1}*yilij{i}' + (1-pmj{1})*(1-yilij{i}'));
    
    ximli(i,1)={zeros(K,ci(i))};
    
    visited_yilij = zeros(ci(i),1);
    visited_pmj = zeros(K,1);
    
    mismatches_row = zeros(ci(i)*K,3); % every row means: [cost to assign li to m, li, m]
    for li=1:ci(i)
        for m = 1:K
            mismatches_row(m+K*(li-1),:) = [mismatches(m,li),li,m];
        end
    end
    [~,perm] = sort(mismatches_row(:,1)); % sorts according to the cost of linking each pile to each summary pile
    mismatches_row = mismatches_row(perm,:);
    ii=1;
    while sum(visited_yilij)<ci(i)
        if visited_yilij(mismatches_row(ii,2)) == 0 && visited_pmj(mismatches_row(ii,3)) == 0
            visited_pmj(mismatches_row(ii,3)) = 1;
            visited_yilij(mismatches_row(ii,2)) = 1;
            Z = Z + mismatches_row(ii,1);
            ximli{i}(mismatches_row(ii,3),mismatches_row(ii,2))=1;
        end
        ii = ii + 1;
    end
end

end