%% This function computes the true positive, true negative and covering rates of a given solution
function [truePos,trueNeg,covRate] = rating(pmj,yilij,ximli,weights)

[K,J]=size(pmj{1});
I=length(yilij);
ci=zeros(1,I);
for i=1:I
    ci(i)=size(yilij{i},1);
end

count_mj=zeros(K,J); % number of times consumers put product j in piles
                     % that are covered by the summary pile m
                     
count_mj_neg=zeros(K,J); % number of times consumers didnt put product j
                     % in piles that are covered by the summary pile m

covering_count_m=zeros(K,1); % number of piles that summary pile m is
                             % covering
for m=1:K
    for i=1:I
        for li=1:ci(i)
            if ximli{i}(m,li)==1
                covering_count_m(m)=covering_count_m(m)+weights{1}(li);
                for j=1:J
                    if yilij{i}(li,j)==1 && pmj{1}(m,j)==1
                        count_mj(m,j)=count_mj(m,j)+weights{1}(li);
                    end
                    if yilij{i}(li,j)==0 && pmj{1}(m,j)==0
                        count_mj_neg(m,j)=count_mj_neg(m,j)+weights{1}(li);
                    end
                end
            end
        end
    end
end

truePos=zeros(K,J);
trueNeg=zeros(K,J);
covRate=zeros(K,1);

for m=1:K
    if covering_count_m(m)~=0
        truePos(m,:)=count_mj(m,:)/covering_count_m(m);
        trueNeg(m,:)=count_mj_neg(m,:)/covering_count_m(m);
    else
        truePos(m,:)=zeros(1,J);
        trueNeg(m,:)=zeros(1,J);
    end
    covRate(m)=covering_count_m(m)/sum(covering_count_m);
end

end

