%% Function that choses randomly (with roulette) what group the pile must join given the miscoverings. "current_pile" won't be chosen
function [m] = roulette(miscoverings,current_pile)

K=length(miscoverings);

if K==1
    m=1;
    return;
end

summary_piles=1:K;
miscoverings=miscoverings([1:current_pile-1,current_pile+1:end]); % remove miscoverings of "current_pile"
summary_piles=summary_piles([1:current_pile-1,current_pile+1:end]); % remove "current_pile" itself
total=sum(miscoverings);
int_probs=total-miscoverings;  % "integer probability"
if sum(int_probs)~=0
    probs=int_probs/sum(int_probs);
else     % it means that there's only one pile remaining
    probs=1;
end
ac=zeros(1,K-1);
ac(1)=probs(1);  % cumulative probability
if length(probs)>1
    for i=2:K-1
        ac(i)=ac(i-1)+probs(i);
    end
end
random_val=rand();
for i=1:K-1
    if ac(i)>=random_val
        m=summary_piles(i);
        break;
    end
end
end

