%% Shaking procedure of VNS. It reassigns k piles to different summary piles
function [new_ximli]=shaking(ximli,pmj,yilij,k)
%% Inputs:
% ximli: cell where each value equals to 1 if pile li is assigned to summary pile m
% pmj: summary piles
% yilij: piles
% k: number of reassignments

%% Output:
% new_ximli: new assignment

%%
J=size(pmj{1},2);
I=length(ximli);
ci=zeros(I,1);
for i=1:I
    ci(i)=size(ximli{i},2);
end

new_ximli = ximli;

for kk=1:k
    i=randi(I);
    li=randi(ci(i)); % get a random pile li
    miscoverings_li=J-(pmj{1}*yilij{i}(li,:)'+(1-pmj{1})*(1-yilij{i}(li,:)')); % compute the mismatches from every summary pile
    for m_ = 1:size(ximli{i},1) % find li's covering summary pile
        if ximli{i}(m_,li)==1
            m = m_;
            break;
        end
    end
    % Assign pile li to a random summay pile where summary piles with less
    % mismatches have more probability to be chosen
    new_m=roulette(miscoverings_li,m);
    new_ximli{i}(m,li)=0;
    new_ximli{i}(new_m,li)=1;
end

end