%% Shaking procedure of VNS when piles from the same individual must be covered by different summay piles. It reassigns k piles to different summary piles
function [new_ximli]=shakingOPPSP(ximli,pmj,yilij,k)
%% Inputs:
% ximli: cell where each value equals to 1 if pile li of individual i is assigned to summary pile m
% pmj: summary piles
% yilij: piles
% k: number of reassignments

%% Output:
% new_ximli: new assignment

%%
[K,J]=size(pmj{1});
I=length(ximli);
ci=zeros(I,1);
for i=1:I
    ci(i)=size(ximli{i},2);
end

new_ximli = ximli;

for kk=1:k
    i=randi(I); % pick a random individual
    while K <= ci(i) % the individual must have less than K piles
        i=randi(I);
    end
    li=randi(ci(i)); % pick a random pile
    miscoverings_li=J-(pmj{1}*yilij{i}(li,:)'+(1-pmj{1})*(1-yilij{i}(li,:)')); % compute the mismatches from every summary pile
    for m_ = 1:size(ximli{i},1) % find li's covering summary pile
        if ximli{i}(m_,li)==1
            m = m_;
            break;
        end
    end
    % Find the set of summary piles that can be chosen to be the new li's
    % summary pile. The chosen summary pile must not cover any pile of
    % individual i
    candidates = zeros(K-ci(i),1);
    c = 1;
    for mm = 1:K
        if sum(ximli{i}(mm,:)) == 0 % if summary pile mm doesn't cover any pile of individual i
            candidates(c) = mm;
            c = c + 1;
        end
    end
    % Assign pile li to a random summay pile where summary piles with less
    % mismatches have more probability to be chosen
    new_m=rouletteOPPSP(miscoverings_li,candidates);
    new_ximli{i}(m,li)=0;
    new_ximli{i}(new_m,li)=1;
end
end